package INTERCAL::Operators;

use strict;
use vars qw($VERSION @ISA @EXPORT $AUTOLOAD);

require Exporter;

@ISA = qw(Exporter);
@EXPORT = qw(select
	     interleave
	     and16
	     and32
	     or16
	     or32
	     xor16
	     xor32
	     );

$VERSION = '1.0';

sub select {
    my($a, $b) = @_;
    my($i, $j, $r) = (0) x 3;
    foreach $i (0..31) {
 	if($b & (1 << $i)) {
	    $r |= (1 << $j) if $a & (1 << $i);
	    $j++;
	}
    }
    $r;
}
	
sub interleave {
    my($a, $b) = @_;
    my($i, $r) = (0) x 2;
    foreach $i (0..15) {
	$r |= 1 << ($i * 2) if $b & (1 << $i);
	$r |= 1 << ($i * 2 + 1) if $a & (1 << $i);
    }
    $r;
}

sub and {
    my($bits, $a) = @_;
    my($i, $r) = (0) x 2;
    foreach $i (0..$bits - 1) {
	$r |= 1 << $i if ($a & (1 << $i)) && ($a & (1 << (($i + 1) % $bits)));
    }
    $r;
}

sub or {
    my($bits, $a) = @_;
    my($i, $r) = (0) x 2;
    foreach $i (0..$bits - 1) {
	$r |= 1 << $i if ($a & (1 << $i)) || ($a & (1 << (($i + 1) % $bits)));
    }
    $r;
}

sub xor {
    my($bits, $a) = @_;
    my($i, $r) = (0) x 2;
    foreach $i (0..$bits - 1) {
	$r |= 1 << $i if (!($a & (1 << $i))) ^ (!($a & (1 << (($i + 1) % $bits))));
    }
    $r;
}

sub AUTOLOAD {
    my($func, $bits);
    ($func) = $AUTOLOAD =~ /.*::(.*)$/;
    if(($func, $bits) = $func =~ /^(and|or|xor)(16|32)$/) {
	return &{$::{$func}}($bits, @_);
    }
}

1;
